Index: trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_c2d.h90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_c2d.h90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_c2d.h90	(revision 2528)
@@ -7,7 +7,7 @@
 
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -27,7 +27,7 @@
       !!           iso-model level : ahm3, ahm4 not used
       !!
-      !!       biharmonic operator : ahm1 is defined at u-point
-      !!                             ahm2 is defined at v-point
-      !!                           : ahm3, ahm4 not used
+      !!       biharmonic operator : ahm3 is defined at u-point
+      !!                             ahm4 is defined at v-point
+      !!                           : ahm1, ahm2 not used
       !!
       !!----------------------------------------------------------------------
@@ -74,7 +74,8 @@
          ENDIF
 
-         ! Special case for ORCA R2 and R4 configurations (overwrite the value of ahm1 ahm2)
+         ! Special case for ORCA R1, R2 and R4 configurations (overwrite the value of ahm1 ahm2)
          ! ==============================================
          IF( cp_cfg == "orca" .AND. ( jp_cfg == 2 .OR. jp_cfg == 4 ) )   CALL ldf_dyn_c2d_orca( ld_print )
+         IF( cp_cfg == "orca" .AND.   jp_cfg == 1)                       CALL ldf_dyn_c2d_orca_R1( ld_print )
 
          ! Control print
@@ -102,5 +103,5 @@
          IF(lwp) WRITE(numout,*) '              maximum grid-spacing = ', zd_max, ' maximum value for ahm = ', ahm0
 
-         za00 = ahm0 / ( zd_max * zd_max * zd_max )
+         za00 = ahm0_blp / ( zd_max * zd_max * zd_max )
          DO jj = 1, jpj
             DO ji = 1, jpi
@@ -288,2 +289,171 @@
 
    END SUBROUTINE ldf_dyn_c2d_orca
+
+   SUBROUTINE ldf_dyn_c2d_orca_R1( ld_print )
+      !!----------------------------------------------------------------------
+      !!                 ***  ROUTINE ldf_dyn_c2d  ***
+      !!
+      !!                   **** W A R N I N G ****
+      !!
+      !!                ORCA R1 configuration
+      !!                  
+      !!                   **** W A R N I N G ****
+      !!                  
+      !! ** Purpose :   initializations of the lateral viscosity for orca R1
+      !!
+      !! ** Method  :   blah blah blah...
+      !!
+      !!----------------------------------------------------------------------
+      !! * Modules used
+      USE ldftra_oce, ONLY : aht0
+
+      !! * Arguments
+      LOGICAL, INTENT (in) ::   ld_print   ! If true, output arrays on numout
+
+      !! * Local variables
+      INTEGER ::   ji, jj, jn      ! dummy loop indices
+      INTEGER ::   inum            ! temporary logical unit
+      INTEGER ::   iim, ijm
+      INTEGER ::   ifreq, il1, il2, ij, ii
+      INTEGER, DIMENSION(jpidta,jpidta) ::   idata
+      INTEGER, DIMENSION(jpi   ,jpj   ) ::   icof
+
+      REAL(wp) ::   zahmeq, zcoft, zcoff, zmsk, zam20s
+
+      CHARACTER (len=15) ::   clexp
+      !!----------------------------------------------------------------------
+
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) 'inildf: 2d eddy viscosity coefficient'
+      IF(lwp) WRITE(numout,*) '~~~~~~  --'
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) '        orca_r1 ocean model'
+      IF(lwp) WRITE(numout,*)
+
+#if defined key_antarctic
+#     include "ldfdyn_antarctic.h90"
+#elif defined key_arctic
+#     include "ldfdyn_arctic.h90"
+#else
+      ! Read 2d integer array to specify western boundary increase in the
+      ! ===================== equatorial strip (20N-20S) defined at t-points
+
+      CALL ctl_opn( inum, 'ahmcoef', 'UNKNOWN', 'FORMATTED', 'SEQUENTIAL',   &
+         &           1, numout, lwp )
+      REWIND inum
+      READ(inum,9101) clexp, iim, ijm
+      READ(inum,'(/)')
+      ifreq = 40
+      il1 = 1
+      DO jn = 1, jpidta/ifreq+1
+         READ(inum,'(/)')
+         il2 = MIN( jpidta, il1+ifreq-1 )
+         READ(inum,9201) ( ii, ji = il1, il2, 5 )
+         READ(inum,'(/)')
+         DO jj = jpjdta, 1, -1
+            READ(inum,9202) ij, ( idata(ji,jj), ji = il1, il2 )
+         END DO
+         il1 = il1 + ifreq
+      END DO
+      
+      DO jj = 1, nlcj
+         DO ji = 1, nlci
+            icof(ji,jj) = idata( mig(ji), mjg(jj) )
+         END DO
+      END DO
+      DO jj = nlcj+1, jpj
+         DO ji = 1, nlci
+            icof(ji,jj) = icof(ji,nlcj)
+         END DO
+      END DO
+      DO jj = 1, jpj
+         DO ji = nlci+1, jpi
+            icof(ji,jj) = icof(nlci,jj)
+         END DO
+      END DO
+
+ 9101 FORMAT(1x,a15,2i8)
+ 9201 FORMAT(3x,13(i3,12x))
+ 9202 FORMAT(i3,41i3)
+
+
+      ! Set ahm1 and ahm2  ( T- and F- points) (used for laplacian operator)
+      ! =================
+      ! define ahm1 and ahm2 at the right grid point position
+      ! (USER: modify ahm1 and ahm2 following your desiderata)
+      
+      
+      ! Decrease ahm to zahmeq m2/s in the tropics
+      ! (from 90   to 20   degrees: ahm = scaled by local metrics
+      !  from 20   to  2.5 degrees: ahm = decrease in (1-cos)/2
+      !  from  2.5 to  0   degrees: ahm = constant
+      ! symmetric in the south hemisphere)
+
+      zahmeq = aht0
+      zam20s = ahm0*COS( rad * 20. )
+      
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            IF( ABS( gphif(ji,jj) ) >= 20. ) THEN
+!              leave as set in ldf_dyn_c2d
+            ELSEIF( ABS( gphif(ji,jj) ) <= 2.5 ) THEN
+               ahm2(ji,jj) =  zahmeq
+            ELSE
+               ahm2(ji,jj) =  zahmeq + (zam20s-zahmeq)/2.   &
+                  * ( 1. - COS( rad * ( ABS(gphif(ji,jj))-2.5 ) * 180. / 17.5 ) )
+            ENDIF
+            IF( ABS( gphit(ji,jj) ) >= 20. ) THEN
+!             leave as set in ldf_dyn_c2d
+            ELSEIF( ABS( gphit(ji,jj) ) <= 2.5 ) THEN
+               ahm1(ji,jj) =  zahmeq
+            ELSE
+               ahm1(ji,jj) =  zahmeq + (zam20s-zahmeq)/2.   &
+                  * ( 1. - COS( rad * ( ABS(gphit(ji,jj))-2.5 ) * 180. / 17.5 ) )
+            ENDIF
+         END DO
+      END DO
+
+      ! increase along western boundaries of equatorial strip
+      ! t-point
+      DO jj = 1, jpjm1
+         DO ji = 1, jpim1
+          IF( ABS( gphit(ji,jj) ) < 20. ) THEN
+            zcoft = FLOAT( icof(ji,jj) ) / 100.
+            ahm1(ji,jj) = zcoft * ahm0 + (1.-zcoft) * ahm1(ji,jj) 
+          ENDIF
+         END DO
+      END DO
+      ! f-point
+      icof(:,:) = icof(:,:) * tmask(:,:,1)
+      DO jj = 1, jpjm1
+         DO ji = 1, jpim1
+          IF( ABS( gphif(ji,jj) ) < 20. ) THEN
+            zmsk = tmask(ji,jj+1,1) + tmask(ji+1,jj+1,1) + tmask(ji,jj,1) + tmask(ji,jj+1,1)
+            IF( zmsk == 0. ) THEN
+               zcoff = 1.
+            ELSE
+               zcoff = FLOAT( icof(ji,jj+1) + icof(ji+1,jj+1) + icof(ji,jj) + icof(ji,jj+1) )   &
+                     / (zmsk * 100.)
+            ENDIF
+            ahm2(ji,jj) = zcoff * ahm0 + (1.-zcoff) * ahm2(ji,jj)
+          ENDIF
+         END DO
+      END DO
+#endif
+      
+      ! Lateral boundary conditions on ( ahm1, ahm2 )
+      !                                ==============
+      CALL lbc_lnk( ahm1, 'T', 1. )   ! T-point, unchanged sign
+      CALL lbc_lnk( ahm2, 'F', 1. )   ! F-point, unchanged sign
+
+      ! Control print
+      IF( lwp .AND. ld_print ) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'inildf: 2D ahm1 array'
+         CALL prihre(ahm1,jpi,jpj,1,jpi,1,1,jpj,1,1.e-3,numout)
+         WRITE(numout,*)
+         WRITE(numout,*) 'inildf: 2D ahm2 array'
+         CALL prihre(ahm2,jpi,jpj,1,jpi,1,1,jpj,1,1.e-3,numout)
+      ENDIF
+
+   END SUBROUTINE ldf_dyn_c2d_orca_R1
Index: trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_c3d.h90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_c3d.h90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_c3d.h90	(revision 2528)
@@ -4,7 +4,7 @@
 
    !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -26,11 +26,8 @@
       !!       ??? explanation of the default is missing
       !!----------------------------------------------------------------------
-      !! * Modules used
       USE ldftra_oce, ONLY : aht0
-
-      !! * Arguments
+      !!
       LOGICAL, INTENT (in) :: ld_print   ! If true, output arrays on numout
-
-      !! * local variables
+      !!
       INTEGER  ::   ji, jj, jk      ! dummy loop indices
       REAL(wp) ::   &
@@ -86,10 +83,10 @@
 
 
-         ! Special case for ORCA R2 and R4 configurations (overwrite the value of ahm1 ahm2)
+         ! Special case for ORCA R1, R2 and R4 configurations (overwrite the value of ahm1 ahm2)
          ! ==============================================
-         IF( cp_cfg == "orca" .AND. ( jp_cfg == 2 .OR. jp_cfg == 4 ) ) THEN
+         IF( cp_cfg == "orca" .AND. ( jp_cfg == 1 .OR. jp_cfg == 2 .OR. jp_cfg == 4 ) ) THEN 
             IF(lwp) WRITE(numout,*)
-            IF(lwp) WRITE(numout,*) '              ORCA R2 or R4: overwrite the previous definition of ahm'
-            IF(lwp) WRITE(numout,*) '              ============='
+            IF(lwp) WRITE(numout,*) '              ORCA R1, R2 or R4: overwrite the previous definition of ahm'
+            IF(lwp) WRITE(numout,*) '              ================='
             CALL ldf_dyn_c3d_orca( ld_print )
          ENDIF
@@ -122,5 +119,5 @@
          IF(lwp) WRITE(numout,*) '              maximum grid-spacing = ', zd_max, ' maximum value for ahm = ', ahm0
 
-         za00 = ahm0 / ( zd_max * zd_max * zd_max )
+         za00 = ahm0_blp / ( zd_max * zd_max * zd_max )
          DO jj = 1, jpj
             DO ji = 1, jpi
@@ -148,9 +145,5 @@
             END DO
          ELSE                            ! partial steps or s-ccordinate
-# if defined key_zco
-            zc = gdept_0(jpkm1)
-# else
             zc = MAXVAL( fsdept(:,:,jpkm1) )
-# endif
             IF( lk_mpp )   CALL mpp_max( zc )   ! max over the global domain
 
@@ -196,15 +189,12 @@
       !!                  ***  ROUTINE ldf_dyn_c3d  ***
       !!                   
-      !! ** Purpose :   ORCA R2 an R4 only
+      !! ** Purpose :   ORCA R1, R2 and R4 only
       !!
       !! ** Method  :   blah blah blah ....
       !!----------------------------------------------------------------------
-      !! * Modules used
       USE ldftra_oce, ONLY : aht0
-
-      !! * Arguments
+      !!
       LOGICAL, INTENT (in) :: ld_print   ! If true, output arrays on numout
-
-      !! * local variables
+      !!
       INTEGER ::   ji, jj, jk, jn      ! dummy loop indices
       INTEGER ::   ii0, ii1, ij0, ij1  ! temporary integers
@@ -228,5 +218,5 @@
       IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~~~'
       IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) '        orca R2 or R4 ocean model'
+      IF(lwp) WRITE(numout,*) '        orca R1, R2 or R4 ocean model'
       IF(lwp) WRITE(numout,*) '  reduced in the surface Eq. strip '
       IF(lwp) WRITE(numout,*)
@@ -318,4 +308,10 @@
       ENDIF
 
+      IF( jp_cfg == 1 )   THEN
+         zahmeq     = aht0  ! reduced to aht0 on equator; set to ahm0 if no tropical reduction is required
+         zahmm      = ahm0
+         zahm0(:,:) = ahm0
+      ENDIF
+
       DO jj = 1, jpj
          DO ji = 1, jpi
@@ -363,37 +359,38 @@
 
       ! other level: re-increase the coef in the deep ocean
-      
-#if defined key_orca_lev10
-      DO jk = 1, 210
-         zcoef(jk) = 1.
-      END DO
-      DO jk= 211, 230
-         zcoef(jk) = 1. + 0.1 * FLOAT(jk-210)
-      END DO
-      DO jk= 231, 260
-         zcoef(jk) = 3. + 0.2 * FLOAT(jk-230)
-      END DO
-      DO jk= 261, 270
-         zcoef(jk) = 9. + 0.1 * FLOAT(jk-260)
-      END DO
-      DO jk= 271, jpk
-         zcoef(jk) = 10.
-      END DO
-      DO jk= 1, jpk
-         IF(lwp) WRITE(numout,*) 'k= ',jk, 'cof ', zcoef(jk)
-      END DO
-#else
-       DO jk = 1, 21
-         zcoef(jk) = 1.
-      END DO
-      zcoef(22) = 2.
-      zcoef(23) = 3.
-      zcoef(24) = 5.
-      zcoef(25) = 7.
-      zcoef(26) = 9.
-      DO jk = 27, jpk
-         zcoef(jk) = 10.
-      END DO
-#endif
+      !==================================================================
+      ! Prior to v3.3, zcoeff was hardwired according to k-index jk.
+      !
+      ! From v3.3 onwards this has been generalised to a function of 
+      ! depth so that it can be used with any number of levels.
+      !
+      ! The function has been chosen to match the original values (shown
+      ! in the following comments) when using the standard 31 ORCA levels.  
+      !     DO jk = 1, 21
+      !        zcoef(jk) = 1._wp
+      !     END DO
+      !     zcoef(22) = 2._wp
+      !     zcoef(23) = 3._wp
+      !     zcoef(24) = 5._wp
+      !     zcoef(25) = 7._wp
+      !     zcoef(26) = 9._wp
+      !     DO jk = 27, jpk
+      !        zcoef(jk) = 10._wp
+      !     END DO
+      !==================================================================
+
+       IF(lwp) THEN
+          WRITE(numout,*)
+          WRITE(numout,*) '         1D zcoef array '
+          WRITE(numout,*) '         ~~~~~~~~~~~~~~ '
+          WRITE(numout,*)
+          WRITE(numout,*) '    jk        zcoef '
+       ENDIF
+
+      DO jk=1, jpk
+         zcoef(jk) = 1.0_wp + NINT(9.0_wp*(gdept_0(jk)-800.0_wp)/(3000.0_wp-800.0_wp))
+         zcoef(jk) = MIN(10.0_wp, MAX(1.0_wp, zcoef(jk)))
+         IF(lwp) WRITE(numout,'(4x,i3,6x,f7.3)') jk,zcoef(jk)
+      END DO
 
       DO jk = 2, jpk
@@ -402,22 +399,17 @@
       END DO
 
-      IF( jp_cfg == 4 )   THEN
-         ! Limit AHM in Gibraltar strait
+      IF( jp_cfg == 4 )   THEN         ! Limit AHM in Gibraltar strait
          ij0 = 50   ;   ij1 = 53
          ii0 = 69   ;   ii1 = 71
          DO jk = 1, jpk
-            ahm1(mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) , jk) = min( zahmm, ahm1 (mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) , jk) ) 
-            ahm2(mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) , jk) = min( zahmm, ahm2 (mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) , jk) )
-         END DO
-      ENDIF
-      
-      ! Lateral boundary conditions on ( ahm1, ahm2 )
-      !                                ==============
-      CALL lbc_lnk( ahm1, 'T', 1. )   ! T-point, unchanged sign
-      CALL lbc_lnk( ahm2, 'F', 1. )   ! F-point, unchanged sign
-
-      ! Control print
-
-      IF(lwp) THEN
+            ahm1(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1),jk) = MIN( zahmm, ahm1(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1),jk) ) 
+            ahm2(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1),jk) = MIN( zahmm, ahm2(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1),jk) )
+         END DO
+      ENDIF
+      CALL lbc_lnk( ahm1, 'T', 1. )   ! Lateral boundary conditions (unchanged sign)
+      CALL lbc_lnk( ahm2, 'F', 1. )
+
+
+      IF(lwp) THEN                    ! Control print
          WRITE(numout,*)
          WRITE(numout,*) '         3D ahm1 array (k=1)'
@@ -451,8 +443,6 @@
       ahm4 ( :, 1, :) = ahm4 ( :, 2, :)
       
-      ! Lateral boundary conditions on ( ahm3, ahm4 )
-      !                                ==============
-      CALL lbc_lnk( ahm3, 'U', 1. )   ! U-point, unchanged sign
-      CALL lbc_lnk( ahm4, 'V', 1. )   ! V-point, unchanged sign
+      CALL lbc_lnk( ahm3, 'U', 1. )    ! Lateral boundary conditions (unchanged sign)
+      CALL lbc_lnk( ahm4, 'V', 1. )
 
       ! Control print
Index: trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_oce.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_oce.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_oce.F90	(revision 2528)
@@ -17,8 +17,8 @@
    LOGICAL , PUBLIC ::   ln_dynldf_hor   = .TRUE.      !: horizontal (geopotential) direction
    LOGICAL , PUBLIC ::   ln_dynldf_iso   = .FALSE.     !: iso-neutral direction
-   REAL(wp), PUBLIC ::   rn_ahm_0        = 40000._wp   !: lateral eddy viscosity (m2/s)
-   REAL(wp), PUBLIC ::   rn_ahmb_0       =     0._wp   !: lateral background eddy viscosity (m2/s)
-
-   REAL(wp), PUBLIC ::   ahm0, ahmb0                 ! OLD namelist names
+   REAL(wp), PUBLIC ::   rn_ahm_0_lap    = 40000._wp   !: lateral laplacian eddy viscosity (m2/s)
+   REAL(wp), PUBLIC ::   rn_ahmb_0       =     0._wp   !: lateral laplacian background eddy viscosity (m2/s)
+   REAL(wp), PUBLIC ::   rn_ahm_0_blp    =     0._wp   !: lateral bilaplacian eddy viscosity (m4/s)
+   REAL(wp), PUBLIC ::   ahm0, ahmb0, ahm0_blp         ! OLD namelist names
 
 #if defined key_dynldf_c3d
@@ -33,7 +33,7 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!======================================================================
 END MODULE ldfdyn_oce
Index: trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_substitute.h90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_substitute.h90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_substitute.h90	(revision 2528)
@@ -6,8 +6,12 @@
    !!----------------------------------------------------------------------
    !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
+   !!
+   !! fsahmt, fsahmf - used for laplaian operator only
+   !! fsahmu, fsahmv - used for bilaplacian operator only
+   !!
 #if defined key_dynldf_c3d
 !   ' key_dynldf_c3d' :                  3D coefficient
@@ -26,11 +30,11 @@
 #  define   fsahmt(i,j,k)    ahm1(k)
 #  define   fsahmf(i,j,k)    ahm1(k)
-#  define   fsahmu(i,j,k)    ahm1(k)
-#  define   fsahmv(i,j,k)    ahm1(k)
+#  define   fsahmu(i,j,k)    ahm2(k)
+#  define   fsahmv(i,j,k)    ahm2(k)
 #else
 !   default option :               Constant coefficient
 #  define   fsahmt(i,j,k)   ahm0
 #  define   fsahmf(i,j,k)   ahm0
-#  define   fsahmu(i,j,k)   ahm0
-#  define   fsahmv(i,j,k)   ahm0
+#  define   fsahmu(i,j,k)   ahm0_blp
+#  define   fsahmv(i,j,k)   ahm0_blp
 #endif
